#ifndef ITEM_SET_H
#define ITEM_SET_H 1

#include <vector>
#include <iostream>
#include <algorithm>
#include <boost/foreach.hpp>

namespace A_PRIORI{

  typedef unsigned int Item;

  class Itemset{

    friend std::ostream& operator << (std::ostream& os, Itemset & is);
    
  public:  
    Itemset(std::vector<unsigned int>& v) : itemvec_(v){};
    Itemset(unsigned int v[], size_t size) {
      itemvec_.reserve(size);
      for (unsigned int i=0; i < size; i++)
	itemvec_.push_back(v[i]);
    };

    Item& operator[](unsigned int i){ return itemvec_[i]; }    
    Itemset& operator = (Itemset other){
      std::swap(itemvec_, other.itemvec_); 
      return *this;
    };
    
    unsigned int size() { return itemvec_.size(); }

  private:
    typedef std::vector<Item> Itemvec;
    Itemvec itemvec_;    
  };

  typedef std::vector<Itemset> Transaction;

  std::ostream & operator<< ( std::ostream & os, Transaction & ts);  

};

#endif
